unit UAcessos;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, DB, StdCtrls,
  Buttons, ImgList, TreeSeguranca, Mask, DBCtrls, Provider,
  SqlExpr, DBClient;

type
  TfrmAcessos = class(TForm)
    GroupBox: TGroupBox;
    TreeSeguranca: TTreeSeguranca;
    bbtOK: TBitBtn;
    ImageList1: TImageList;
    Panel1: TPanel;
    dbcUsuarios: TDBLookupComboBox;
    dbtNome: TDBText;
    Bevel1: TBevel;
    bbtGRAVAR: TBitBtn;
    bbtCANCELAR: TBitBtn;
    bbtFECHAR: TBitBtn;
    procedure FormActivate(Sender: TObject);
    procedure bbtOKClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure bbtGRAVARClick(Sender: TObject);
    procedure bbtCANCELARClick(Sender: TObject);
    procedure bbtFECHARClick(Sender: TObject);
  private
    { Private declarations }
    procedure HabilitaDesabilita;

  public
    { Public declarations }
  end;

var
  frmAcessos: TfrmAcessos;

implementation

uses UDmCadastro, UPrincipal;

{$R *.dfm}

procedure TfrmAcessos.FormActivate(Sender: TObject);
begin
   dtmDados.cdsUsuario.Open;
   dbtNome.Caption := '';

   // indica em qual formulario esta o menu principal
   TreeSeguranca.pFormulario := frmMenu;
end;

// botao Ok
procedure TfrmAcessos.bbtOKClick(Sender: TObject);
begin
   // passa o codigo do usuario para o componente
   TreeSeguranca.pUsuario := dtmDados.cdsUsuarioUSUARIO.Value;
   // ativo a arvore
   TreeSeguranca.AtivaTree;

   HabilitaDesabilita;
end;

// fechamento do formulario
procedure TfrmAcessos.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   dtmDados.cdsUsuario.Close;
end;

// habilito e desabilito os botoes e outros componentes visuais necessarios
procedure TfrmAcessos.HabilitaDesabilita;
begin
   TreeSeguranca.Enabled := not TreeSeguranca.Enabled;

   bbtGRAVAR.Enabled     := not bbtGRAVAR.Enabled;
   bbtCANCELAR.Enabled   := not bbtCANCELAR.Enabled;
   bbtOK.Enabled         := not bbtOK.Enabled;

   dbcUsuarios.Enabled   := not dbcUsuarios.Enabled;
   dbtNome.Enabled       := not dbtNome.Enabled;
end;

procedure TfrmAcessos.bbtGRAVARClick(Sender: TObject);
begin
  // grava os itens da grade marcada na tabela
  TreeSeguranca.Salvar;

   HabilitaDesabilita;
end;

// botao cancelar
procedure TfrmAcessos.bbtCANCELARClick(Sender: TObject);
begin
   HabilitaDesabilita;
   dbtNome.Caption := '';
End;

// botao fechar
procedure TfrmAcessos.bbtFECHARClick(Sender: TObject);
begin
   Close;
end;

end.

